﻿using IgApp.Models;
using Infragistics.Web.Mvc;
using Microsoft.AspNetCore.Mvc;
using System.Text.Json;

namespace IgApp.Controllers
{
    public class HomeController : Controller
    {
        public ActionResult Index()
        {
            return View();
        }


        public IEnumerable<Customer> GetCustomers()
        {
            return new List<Customer>
            {
                new Customer { ID=1, Name="John Smith", IsActive=true, Birthdate=new System.DateTime(1978, 5, 14), IsFun=true, TOTAL_SALARIES=1238, FRINGE_RATE=0, JustifiedAmount=0 , BudgetAmount=0},
                new Customer { ID=2, Name="Bob Richards", IsActive=false, Birthdate=new System.DateTime(1988, 2, 1), IsFun=false, TOTAL_SALARIES=52524, FRINGE_RATE=0, JustifiedAmount=0 , BudgetAmount=0},
                new Customer { ID=3, Name="Marge Wright", IsActive=false,Birthdate=new System.DateTime(1976,11,07), IsFun=false, TOTAL_SALARIES=17543, FRINGE_RATE=0, JustifiedAmount=0 , BudgetAmount=0},
                new Customer { ID=4, Name="Dwight Long", IsActive=true, Birthdate=new System.DateTime(1998,4,08), IsFun=true, TOTAL_SALARIES=16464, FRINGE_RATE=0, JustifiedAmount=0 , BudgetAmount=0},
                new Customer { ID=5, Name="Bob Smith", IsActive=false, Birthdate=new System.DateTime(1998,5,09), IsFun=false, TOTAL_SALARIES=56350, FRINGE_RATE=0, JustifiedAmount=0, BudgetAmount=0 },
                new Customer { ID=6, Name="Abby Tompson", IsActive=false,Birthdate=new System.DateTime(2000,2,07), IsFun=false, TOTAL_SALARIES=23333330, FRINGE_RATE=0, JustifiedAmount=0, BudgetAmount=0 },
                new Customer { ID=7, Name="Dwight Long1", IsActive=true, Birthdate=new System.DateTime(2001,1,08), IsFun=true, TOTAL_SALARIES=16533, FRINGE_RATE=0, JustifiedAmount=0, BudgetAmount=0 },
                new Customer { ID=8, Name="Amy Garnt1", IsActive=true, Birthdate=new System.DateTime(1996,12,09), IsFun=true, TOTAL_SALARIES=14441, FRINGE_RATE=2, JustifiedAmount=500 , BudgetAmount=400},
                new Customer { ID=9, Name="Smith", IsActive=true, Birthdate=new System.DateTime(1967,6,05), IsFun=true, TOTAL_SALARIES=63530, FRINGE_RATE=0, JustifiedAmount=0 , BudgetAmount=0},
                new Customer { ID=10, Name="Richards", IsActive=false, Birthdate=new System.DateTime(1988,6,09), IsFun=false, TOTAL_SALARIES=53430, FRINGE_RATE=0, JustifiedAmount=0 , BudgetAmount=0},
                new Customer { ID=11, Name="Marge Jones", IsActive=false,Birthdate=new System.DateTime(2000,2,07), IsFun=false, TOTAL_SALARIES=23333330, FRINGE_RATE=0, JustifiedAmount=0, BudgetAmount=0 },
                new Customer { ID=12, Name="Dwight Looong", IsActive=true, Birthdate=new System.DateTime(2001,1,08), IsFun=true, TOTAL_SALARIES=16533, FRINGE_RATE=0, JustifiedAmount=0, BudgetAmount=0 },
                new Customer { ID=13, Name="Emily Garnt", IsActive=true, Birthdate=new System.DateTime(1996,12,09), IsFun=true, TOTAL_SALARIES=14441, FRINGE_RATE=2, JustifiedAmount=500 , BudgetAmount=400},
                new Customer { ID=14, Name="Archie Green", IsActive=true, Birthdate=new System.DateTime(1967,6,05), IsFun=true, TOTAL_SALARIES=63530, FRINGE_RATE=0, JustifiedAmount=0 , BudgetAmount=0},
                new Customer { ID=15, Name="Arnold Holmes", IsActive=false, Birthdate=new System.DateTime(1988,6,09), IsFun=false, TOTAL_SALARIES=53430, FRINGE_RATE=0, JustifiedAmount=0 , BudgetAmount=0},
                new Customer { ID=16, Name="Meredith Grey", IsActive=false,Birthdate=new System.DateTime(2000,2,07), IsFun=false, TOTAL_SALARIES=23333330, FRINGE_RATE=0, JustifiedAmount=0, BudgetAmount=0 },
                new Customer { ID=17, Name="John Snow", IsActive=true, Birthdate=new System.DateTime(2001,1,08), IsFun=true, TOTAL_SALARIES=16533, FRINGE_RATE=0, JustifiedAmount=0, BudgetAmount=0 },
                new Customer { ID=18, Name="Ted Mosby", IsActive=true, Birthdate=new System.DateTime(1996,12,09), IsFun=true, TOTAL_SALARIES=14441, FRINGE_RATE=2, JustifiedAmount=500 , BudgetAmount=400},
                new Customer { ID=19, Name="Rick Morty", IsActive=true, Birthdate=new System.DateTime(1967,6,05), IsFun=true, TOTAL_SALARIES=63530, FRINGE_RATE=0, JustifiedAmount=0 , BudgetAmount=0},
                new Customer { ID=20, Name="Albert Maroon", IsActive=false, Birthdate=new System.DateTime(1988,6,09), IsFun=false, TOTAL_SALARIES=53430, FRINGE_RATE=0, JustifiedAmount=0 , BudgetAmount=0},
                new Customer { ID=21, Name="Marshal Jones", IsActive=false,Birthdate=new System.DateTime(2000,2,07), IsFun=false, TOTAL_SALARIES=23333330, FRINGE_RATE=0, JustifiedAmount=0, BudgetAmount=0 },
                new Customer { ID=22, Name="Dr. Who", IsActive=true, Birthdate=new System.DateTime(2001,1,08), IsFun=true, TOTAL_SALARIES=16533, FRINGE_RATE=0, JustifiedAmount=0, BudgetAmount=0 },
                new Customer { ID=23, Name="Edel Weiss", IsActive=true, Birthdate=new System.DateTime(1996,12,09), IsFun=true, TOTAL_SALARIES=14441, FRINGE_RATE=2, JustifiedAmount=500 , BudgetAmount=400},
                new Customer { ID=24, Name="Rose Tulip", IsActive=true, Birthdate=new System.DateTime(1967,6,05), IsFun=true, TOTAL_SALARIES=63530, FRINGE_RATE=0, JustifiedAmount=0 , BudgetAmount=0},
                new Customer { ID=25, Name="Clark Ken", IsActive=false, Birthdate=new System.DateTime(1988,6,09), IsFun=false, TOTAL_SALARIES=53430, FRINGE_RATE=0, JustifiedAmount=0 , BudgetAmount=0},
            };

        }

        public JsonResult GetDataPaging(int page, int pageSize)
        {
            IEnumerable<Customer> customers = GetCustomers();
            IQueryable data = customers.AsQueryable();
            int totalCount = data.Count();

            data = data.Skip(page * pageSize).Take(pageSize);

            JsonResult result = new JsonResult(new { }, new JsonSerializerOptions { PropertyNamingPolicy = null });
            result.Value = new { Records = data, TotalRecordsCount = totalCount };
            return result;
        }
    }
}